/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2006-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: chip_kernel.h 1094 2015-02-10 02:38:30Z ertl-honda $
 */

/*
 *  kernel.hΥåװ¸MPCOREѡ
 *
 *  Υ󥯥롼ɥեϡkernel.hǥ󥯥롼ɤ롥¾Υե
 *  뤫ľܥ󥯥롼ɤ뤳ȤϤʤΥե򥤥󥯥롼
 *  ˡt_stddef.h󥯥롼ɤΤǡ˰¸Ƥ
 *  
 */

#ifndef TOPPERS_CHIP_KERNEL_H
#define TOPPERS_CHIP_KERNEL_H

#include "mpcore.h"

/*
 *  ARMǶ̤
 */
#include "arm_gcc/common/core_kernel.h"

/*
 *  ݡȤ뵡ǽ
 */
#define TOPPERS_TARGET_SUPPORT_ENA_INT			/* ena_int򥵥ݡȤ */
#define TOPPERS_TARGET_SUPPORT_DIS_INT			/* dis_int򥵥ݡȤ */
#ifdef TOPPERS_SYSTIM_LOCAL
#define TOPPERS_TARGET_SUPPORT_GET_UTM			/* get_utm򥵥ݡȤ */
#endif /* TOPPERS_SYSTIM_LOCAL */

/*
 *  CustomΥɥ
 */
#define TOPPERS_CUSTOM_IDLE

/*
 *  ͥ٤ϰ
 */
#if __TARGET_ARCH_ARM == 6
#define TMIN_INTPRI   (-15)   /* ͥ٤κǾ͡ʺǹ͡*/
#define TMAX_INTPRI   (-1)    /* ͥ٤κ͡ʺ͡*/
#else /* __TARGET_ARCH_ARM == 7 */
#ifdef TOPPERS_SAFEG_NONSECURE
#define TMIN_INTPRI   (-15)   /* ͥ٤κǾ͡ʺǹ͡*/
#define TMAX_INTPRI   (-1)    /* ͥ٤κ͡ʺ͡*/
#elif defined(TOPPERS_SAFEG_SECURE)
#define TMIN_INTPRI   (-31)   /* ͥ٤κǾ͡ʺǹ͡*/
#define TMAX_INTPRI   (-16)   /* ͥ٤κ͡ʺ͡*/
#else /* !TOPPERS_SAFEG_NONSECURE */
#define TMIN_INTPRI   (-31)   /* ͥ٤κǾ͡ʺǹ͡*/
#define TMAX_INTPRI   (-1)    /* ͥ٤κ͡ʺ͡*/
#endif /* TOPPERS_SAFEG_NONSECURE */

#endif /* __TARGET_ARCH_ARM == 7 */


/*
 *  ƥå
 */
#define TIC_NUME  1U   /* ƥåμʬ */
#define TIC_DENO  1U   /* ƥåμʬ */

#ifndef TOPPERS_MACRO_ONLY
#if __TARGET_ARCH_ARM == 7
/*
 *  ǽɾѤδؿ
 *  CA9/MPCore  r1ʹߤܤƤ Global Timer Ѥ롥
 */

/* ǽ¬ѤΥ󥿤Υǡ */
typedef uint64_t PERFCNT;

/*
 *  ѥեޥ󥹥󥿤ν
 */
Inline void
x_init_pcc(void)
{
	/*  */
	sil_wrw_mem((void *)MPCORE_GTC_CNT, 0);

	/* 󥿡쥸ν */
	sil_wrw_mem((void *)MPCORE_GTC_COUNT_L, 0);
	sil_wrw_mem((void *)MPCORE_GTC_COUNT_U, 0);

	/* ڥХ塼쥸ν */
	sil_wrw_mem((void *)MPCORE_GTC_COMPV_L, 0xffffffff);
	sil_wrw_mem((void *)MPCORE_GTC_COMPV_U, 0xffffffff);

	/* ȳ */
	sil_wrw_mem((void *)MPCORE_GTC_CNT, MPCORE_GTC_CNT_TIMENA);
}

/*
 *  ѥեޥ󥹥󥿤ɤ߹
 */
Inline void
x_get_pcc(PERFCNT *p_count)
{
	uint32_t count_l;
	uint32_t count_h_p, count_h;

	/*
	 * 32bit2Ĥ64bit󥿤¸Ƥ뤿ᡤ
	 * 夲θɤ߹ߤȤ롥
	 */
	count_h_p = sil_rew_mem((void *)MPCORE_GTC_COUNT_U);
	count_l = sil_rew_mem((void *)MPCORE_GTC_COUNT_L);
	count_h = sil_rew_mem((void *)MPCORE_GTC_COUNT_U);
	if (count_h_p != count_h) {
		count_l = sil_rew_mem((void *)MPCORE_GTC_COUNT_L);
	}

	*p_count = count_h;
	*p_count = *p_count << 32;
	*p_count += count_l;
}

/*
 *  ѥեޥ󥹥󥿤Υꥻå
 */
Inline void
x_rst_pcc(void)
{
	uint32_t tmp, tmp1;

	/*  */
	tmp = sil_rew_mem((void *)MPCORE_GTC_CNT);
	tmp1 = tmp & ~MPCORE_GTC_CNT_TIMENA;
	sil_wrw_mem((void *)MPCORE_GTC_CNT, tmp1);

	/* 󥿡쥸ν */
	sil_wrw_mem((void *)MPCORE_GTC_COUNT_L, 0);
	sil_wrw_mem((void *)MPCORE_GTC_COUNT_U, 0);

	/* 󥿺Ƴ */
	sil_wrw_mem((void *)MPCORE_GTC_CNT, tmp);
}

/*
 *  ͤnsecؤѴ
 */
Inline uint64_t
x_cnv_nsec(PERFCNT count) {
	return (count * (1000U / MPCORE_GTC_CLOCK_FREQ_MHZ));
}

#endif /* __TARGET_ARCH_ARM == 7 */
#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS__KERNEL_H */
