/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2013 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: target_support.S 1019 2013-07-11 13:29:21Z ertl-honda $
 */

#define  TOPPERS_MACRO_ONLY
#include "kernel_impl.h"
#include "target_asm.inc"

#ifdef TOPPERS_SAFEG_SECURE
/* 
 *  First NT switch function.
 *  This function is copied to OCM at boot time.
 */
    ATEXT
    AALIGN(2)
    AGLOBAL(first_switch_to_nt)
    AGLOBAL(first_switch_to_nt_end)
ALABEL(first_switch_to_nt)
	my_core_index r0
	cmp   r0, #1
	beq   safeg_prc2_boot
	/* In case of Core0 */
	movw  r1, #(TARGET_CORE0_NS_START_ADDR & 0xffff)
	movt  r1, #((TARGET_CORE0_NS_START_ADDR >> 16) & 0xffff)
	bx    r1
safeg_prc2_boot:
	/* In case of Core0 */
	movw  r1, #(BOOT_MEM_ADDR & 0xffff)
	movt  r1, #((BOOT_MEM_ADDR >> 16) & 0xffff)
1:
	ldr   r0, [r1]
	cmp   r0, #0
	beq   1b
	mov   r2, #0
	str   r2, [r1]
	bx    r0
ALABEL(first_switch_to_nt_end)
#endif /* TOPPERS_SAFEG_SECURE */
